--- a/nptl/Versions
+++ b/nptl/Versions
@@ -30,6 +30,7 @@ libc {
     __libc_alloca_cutoff;
     # Internal libc interface to libpthread
     __libc_dl_error_tsd;
+    __libc_vfork;
   }
 }
 
@@ -257,6 +258,9 @@ libpthread {
     pthread_setattr_default_np;
   }
 
+  GLIBC_2.20 {
+  }
+
   GLIBC_PRIVATE {
     __pthread_initialize_minimal;
     __pthread_clock_gettime; __pthread_clock_settime;
--- /dev/null
+++ b/nptl/pt-vfork.c
@@ -0,0 +1,77 @@
+/* vfork ABI-compatibility entry points for libpthread.
+   Copyright (C) 2014 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <unistd.h>
+#include <shlib-compat.h>
+
+/* libpthread used to have its own vfork implementation that differed
+   from libc's only in having a pointless micro-optimization.  There
+   is no longer any use to having a separate copy in libpthread, but
+   the historical ABI requires it.  For static linking, there is no
+   need to provide anything here--the libc version will be linked in.
+   For shared library ABI compatibility, there must be __vfork and
+   vfork symbols in libpthread.so; so we define them using IFUNC to
+   redirect to the libc function.  */
+
+#if (SHLIB_COMPAT (libpthread, GLIBC_2_0, GLIBC_2_20) \
+     || SHLIB_COMPAT (libpthread, GLIBC_2_1_2, GLIBC_2_20))
+
+extern __typeof (vfork) __libc_vfork;   /* Defined in libc.  */
+
+# ifdef HAVE_IFUNC
+
+attribute_hidden __attribute__ ((used))
+__typeof (vfork) *
+vfork_ifunc (void)
+{
+  return &__libc_vfork;
+}
+
+#  ifdef HAVE_ASM_SET_DIRECTIVE
+#   define DEFINE_VFORK(name) \
+  asm (".set " #name ", vfork_ifunc\n" \
+       ".globl " #name "\n" \
+       ".type " #name ", %gnu_indirect_function");
+#  else
+#   define DEFINE_VFORK(name) \
+  asm (#name " = vfork_ifunc\n" \
+       ".globl " #name "\n" \
+       ".type " #name ", %gnu_indirect_function");
+#  endif
+
+# else
+
+attribute_hidden
+pid_t
+vfork_compat (void)
+{
+  return __libc_vfork ();
+}
+
+# define DEFINE_VFORK(name)     weak_alias (vfork_compat, name)
+
+# endif
+#endif
+
+#if SHLIB_COMPAT (libpthread, GLIBC_2_0, GLIBC_2_20)
+DEFINE_VFORK (vfork)
+#endif
+
+#if SHLIB_COMPAT (libpthread, GLIBC_2_1_2, GLIBC_2_20)
+DEFINE_VFORK (__vfork)
+#endif
--- a/sysdeps/unix/sysv/linux/arm/nptl/pt-vfork.S
+++ /dev/null
@@ -1,34 +0,0 @@
-/* Copyright (C) 2005-2014 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <tcb-offsets.h>
-
-/* Save the PID value.  */
-#define SAVE_PID \
-	GET_TLS (r2);							\
-	NEGOFF_ADJ_BASE2 (r2, r0, PID_OFFSET); /* Save the TLS addr in r2. */ \
-	ldr	r3, NEGOFF_OFF1 (r2, PID_OFFSET); /* Load the saved PID.  */  \
-	rsb	r0, r3, #0;		/* Negate it.  */		     \
-	str	r0, NEGOFF_OFF1 (r2, PID_OFFSET); /* Store the temp PID.  */
-
-/* Restore the old PID value in the parent.  */
-#define RESTORE_PID \
-	cmp	r0, #0;			/* If we are the parent... */	\
-	it	ne;							\
-	strne	r3, NEGOFF_OFF1 (r2, PID_OFFSET); /* restore the saved PID.  */
-
-#include "../vfork.S"
--- a/sysdeps/unix/sysv/linux/arm/nptl/vfork.S
+++ /dev/null
@@ -1,36 +0,0 @@
-/* Copyright (C) 2005-2014 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <tcb-offsets.h>
-
-/* Save the PID value.  */
-#define SAVE_PID \
-	GET_TLS (r2);							\
-	NEGOFF_ADJ_BASE2 (r2, r0, PID_OFFSET); /* Save the TLS addr in r2.  */ \
-	ldr	r3, NEGOFF_OFF1 (r2, PID_OFFSET); /* Load the saved PID.  */   \
-	rsbs	r0, r3, #0;		/* Negate it.  */		      \
-	it	eq;							      \
-	moveq	r0, #0x80000000;	/* Use 0x80000000 if it was 0.  */    \
-	str	r0, NEGOFF_OFF1 (r2, PID_OFFSET); /* Store the temp PID.  */
-
-/* Restore the old PID value in the parent.  */
-#define RESTORE_PID \
-	cmp	r0, #0;		/* If we are the parent... */		\
-	it	ne;							\
-	strne	r3, NEGOFF_OFF1 (r2, PID_OFFSET); /* restore the saved PID.  */
-
-#include "../vfork.S"
--- a/sysdeps/unix/sysv/linux/arm/vfork.S
+++ b/sysdeps/unix/sysv/linux/arm/vfork.S
@@ -19,6 +19,8 @@
 #include <sysdep.h>
 #define _ERRNO_H	1
 #include <bits/errno.h>
+#include <tcb-offsets.h>
+
 
 /* Clone the calling process, but without copying the whole address space.
    The calling process is suspended until the new process exits or is
@@ -26,9 +28,16 @@
    and the process ID of the new process to the old process.  */
 
 ENTRY (__vfork)
-#ifdef SAVE_PID
-	SAVE_PID
-#endif
+	/* Save the PID value.  */
+	GET_TLS (r2)
+	NEGOFF_ADJ_BASE2 (r2, r0, PID_OFFSET) /* Save the TLS addr in r2.  */
+	ldr	r3, NEGOFF_OFF1 (r2, PID_OFFSET) /* Load the saved PID.  */
+	rsbs	r0, r3, #0		/* Negate it, and test for zero.  */
+	/* Use 0x80000000 if it was 0.  See raise.c for how this is used.  */
+	it	eq
+	moveq	r0, #0x80000000
+	str	r0, NEGOFF_OFF1 (r2, PID_OFFSET) /* Store the temp PID.  */
+
 	/* The DO_CALL macro saves r7 on the stack, to enable generation
 	   of ARM unwind info.  Since the stack is initially shared between
 	   parent and child of vfork, that saved value could be corrupted.
@@ -46,10 +55,13 @@ ENTRY (__vfork)
 	add	sp, sp, #4
 	cfi_adjust_cfa_offset (-4)
 	mov	r7, ip
-	cfi_restore (r7);
-#ifdef RESTORE_PID
-	RESTORE_PID
-#endif
+	cfi_restore (r7)
+
+	/* Restore the old PID value in the parent.  */
+	cmp	r0, #0		/* If we are the parent... */
+	it	ne
+	strne	r3, NEGOFF_OFF1 (r2, PID_OFFSET) /* restore the saved PID.  */
+
 	cmn	a1, #4096
 	it	cc
 	RETINSTR(cc, lr)
@@ -59,3 +71,4 @@ PSEUDO_END (__vfork)
 libc_hidden_def (__vfork)
 
 weak_alias (__vfork, vfork)
+strong_alias (__vfork, __libc_vfork)